VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form Form1 
   Caption         =   "Trisection and trilateration MARV1. 6/2007-16.6.2011 (c) Ilkka Korpela. Hy-temp -version"
   ClientHeight    =   8070
   ClientLeft      =   225
   ClientTop       =   855
   ClientWidth     =   15090
   LinkTopic       =   "Form1"
   ScaleHeight     =   8070
   ScaleWidth      =   15090
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox List1 
      BeginProperty Font 
         Name            =   "Fixedsys"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   6135
      Left            =   5640
      TabIndex        =   1
      Top             =   240
      Width           =   9015
   End
   Begin VB.PictureBox Picture1 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      Height          =   5175
      Left            =   120
      ScaleHeight     =   341
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   341
      TabIndex        =   0
      Top             =   240
      Width           =   5175
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   240
      Top             =   7080
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Menu File 
      Caption         =   "File"
      Begin VB.Menu Open_PhotogrammetricMap 
         Caption         =   "Open photogrammetric map (ilmakuvapuut)"
      End
      Begin VB.Menu OPen_Field_observations 
         Caption         =   "Open field observations (suuntimat)"
      End
      Begin VB.Menu Simulate 
         Caption         =   "Calculate positions (tasoituslaskenta)"
      End
      Begin VB.Menu Exit_Program 
         Caption         =   "Exit Program"
      End
   End
   Begin VB.Menu Help 
      Caption         =   "Help"
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub Exit_Program_Click()
End
End Sub

Private Sub Form_Load()

Rem Check the comma and list separators

On Error GoTo ErrorLoadingProgram

Open "C:\HY-temp\PILKKUTESTI.TXT" For Output As 1
Print #1, Format$(1#, "#.0")
Print #1, 1 & ","; 2 & "," & 3
Close (1)
Dim cdummy As String, l1 As Long, l2 As Long, l3 As Long
Open "C:\HY-temp\PILKKUTESTI.TXT" For Input As 1
Input #1, cdummy
If Mid$(cdummy, 2, 1) <> "." Then MsgBox ("RESECTION requires the use of point as decimal separator")
Input #1, l1, l2, l3
If l1 <> 1 Or l2 <> 2 Or l3 <> 3 Then MsgBox ("RESECTION requires the use of comma as list separator")
Close (1)
Kill "C:\HY-temp\pilkkutesti.txt"
Exit Sub
ErrorLoadingProgram:
MsgBox ("RESECTION is badly written:; it assumes I/O access to C:\HY-temp -folder, point (.) as decimal and comma (,) as list separator!")

End Sub

Private Sub Help_Click()
Form2.Visible = True
Load Form2
End Sub

Private Sub List1_DblClick()
Index = List1.ListIndex
Picture1.Cls
Dim MinP As Point3D, MaxP As Point3D
MinP.X = 1E+20: MinP.Y = 1E+20
MaxP.X = -1E+20: MaxP.Y = -1E+20
For i = 1 To sobs(Index).NPA
   MinP.X = Min(MinP.X, sobs(Index).TreePos(i).X)
   MinP.Y = Min(MinP.Y, sobs(Index).TreePos(i).Y)
   MaxP.X = Max(MaxP.X, sobs(Index).TreePos(i).X)
   MaxP.Y = Max(MaxP.Y, sobs(Index).TreePos(i).Y)
Next i

Xdist = MaxP.X - MinP.X + 3
Ydist = MaxP.Y - MinP.Y + 3
box = Max(Xdist, Ydist) * 1.2
Rem The size of the area is 1.2 * box


aa = Picture1.ScaleHeight

Ltm = Picture1.ScaleWidth / box
Picture1.ForeColor = RGB(0, 0, 0)
Picture1.Line ((3) * Ltm, aa - (box - 1) * Ltm)-((6) * Ltm, aa - (box - 1) * Ltm)
Picture1.Font = "Arial"
Picture1.FontSize = 12
Picture1.FontBold = True
Picture1.CurrentY = Picture1.CurrentY - 10
Picture1.Print "3 m"

For i = 1 To sobs(Index).NPA

  xp = (sobs(Index).TreePos(i).X - MinP.X + 3) * Ltm
  yp = (MaxP.Y - sobs(Index).TreePos(i).Y + 3) * Ltm
  
  Picture1.Circle (xp, yp), 5
  Picture1.ForeColor = RGB(255, 0, 0)
  Picture1.Print sobs(Index).TreeNum(i)
  Picture1.ForeColor = RGB(0, 0, 0)
  ObsDist = sobs(Index).Distance(i)
     If sobs(Index).Bussol(i) < 180 Then
       sobs(Index).Bussol(i) = sobs(Index).Bussol(i) + 180
       GoTo Defined
     End If
     If sobs(Index).Bussol(i) >= 180 Then
       sobs(Index).Bussol(i) = sobs(Index).Bussol(i) - 180
     End If
Defined:
     If sobs(Index).Bussol(i) < 360 - BK Then
        TrueAzim = sobs(Index).Bussol(i) + BK
     Else
        TrueAzim = -(360 - sobs(Index).Bussol(i)) + BK
     End If
     If TrueAzim >= 90 And TrueAzim <= 270 Then ObsAzim = TO_RADIANS * (-(TrueAzim - 90))
     If TrueAzim > 0 And TrueAzim <= 90 Then ObsAzim = TO_RADIANS * (90 - TrueAzim)
     If TrueAzim > 270 And TrueAzim <= 360 Then ObsAzim = (5 * PI / 2 - 2 * PI / 360 * TrueAzim)
     TrueAzim = ObsAzim
  
   xpp = xp + Cos(TrueAzim) * box * Ltm
   ypp = (MaxP.Y - (sobs(Index).TreePos(i).Y - 3 + Sin(TrueAzim) * box)) * Ltm
    Picture1.CurrentX = xp
    Picture1.CurrentX = yp
    Picture1.DrawWidth = 1
    Picture1.Line (xp, yp)-(xpp, ypp)
  
  
  
Next i


Open InputParam.OutputFilename For Input As 1
Line Input #1, Cheader
For j = 1 To Index - 1
 Line Input #1, Cheader
Next j
 Input #1, k, Nite, plotNum, Tree, Sp, IniX, IniY, AdjX, Adjy
   xp = (AdjX - MinP.X + 3) * Ltm
  yp = (MaxP.Y - Adjy + 3) * Ltm
  Picture1.FillColor = RGB(255, 0, 0)
  Picture1.FillStyle = 0
  Picture1.Circle (xp, yp), 3, RGB(255, 0, 0)
  Picture1.FillStyle = 1
  xp = (IniX - MinP.X + 3) * Ltm
  yp = (MaxP.Y - IniY + 3) * Ltm
    Picture1.ForeColor = RGB(0, 0, 255)
  Picture1.Circle (xp, yp), 5

 
 
Close (1)

End Sub

Private Sub OPen_Field_observations_Click()

CommonDialog1.Filter = "Sighting obs files (*.txt, *.csv)|*.*"
CommonDialog1.DialogTitle = "File which has sightings-data!"
CommonDialog1.Action = 1

'Open CommonDialog1.FileName For Input As 1
Close (1)
Open CommonDialog1.FileName For Input As 1
Rem Start processing
Dim Line As Long
ReDim sobs(1 To 2000) As Sighting
Dim StartPoints(1 To 2000) As Long
Dim l As Long
Dim capu As String

nobs = 0
Do Until EOF(1)
 Line = Line + 1
 If EOF(1) = True Then GoTo DoneReading
  Rem read a line of data into  a string, let string lenght deterimine the type of observation
  Rem PLOT_ID, TREE_ID, NPA, (ID, DIST, AZI) * 5
  nobs = nobs + 1
  Input #1, sobs(nobs).plotNum, sobs(nobs).Ntree, sobs(nobs).Sp, sobs(nobs).NPA, sobs(nobs).TreeNum(1), sobs(nobs).Distance(1), sobs(nobs).Bussol(1), sobs(nobs).TreeNum(2), sobs(nobs).Distance(2), sobs(nobs).Bussol(2), sobs(nobs).TreeNum(3), sobs(nobs).Distance(3), sobs(nobs).Bussol(3), sobs(nobs).TreeNum(4), sobs(nobs).Distance(4), sobs(nobs).Bussol(4), sobs(nobs).TreeNum(5), sobs(nobs).Distance(5), sobs(nobs).Bussol(5)
  For k = 1 To 5
    If k <= sobs(nobs).NPA Then
     For l = 1 To UBound(Trees())
      If Trees(l).num = sobs(nobs).TreeNum(k) And Trees(l).plotNum = sobs(nobs).plotNum Then
       sobs(nobs).TreePos(k).X = Trees(l).Pos.X
       sobs(nobs).TreePos(k).Y = Trees(l).Pos.Y
       sobs(nobs).TreePos(k).Z = Trees(l).Pos.Z
       sobs(nobs).TreeSp(k) = Trees(l).spec
       sobs(nobs).Distance(k) = sobs(nobs).Distance(k) '+ Trees(l).d13 / 2
       If sobs(nobs).Bussol(k) > -1 Then
        sobs(nobs).IsBussol(k) = True
        sobs(nobs).Nazim = sobs(nobs).Nazim + 1
       End If
       If sobs(nobs).Distance(k) > -1 Then
        sobs(nobs).IsDistance(k) = True
        sobs(nobs).Ndist = sobs(nobs).Ndist + 1
       End If
      End If
     Next l
    End If
  Next k
    
Loop
DoneReading:
MsgBox (nobs & " observed trees to be positioned ")
Close (1)


End Sub

Private Sub Open_PhotogrammetricMap_Click()

'On Error GoTo Virhetilanne
CommonDialog1.Filter = "Field plot data files (*.txt, *.csv)|*.*"
CommonDialog1.DialogTitle = "File which has photogrammetric control points!"
CommonDialog1.Action = 1
CommonDialog1.InitDir = ""
Open CommonDialog1.FileName For Input As 1

Rem Allocate storage for 5700 tree-observations
ReDim Trees(1 To 5700) As PhotoTree

Dim n As Long, dummy As String
n = 1
Line Input #1, dummy
Do Until EOF(1)
 Input #1, Trees(n).plotNum, Trees(n).num, Trees(n).spec, Trees(n).Pos.X, Trees(n).Pos.Y, Trees(n).Pos.Z, Trees(n).Zbutt, Trees(n).Lidar_h, Trees(n).foto_h, Trees(n).d13, Trees(n).Dcrm_LiDAR, Trees(n).Dcrm_RMSE, Trees(n).Dist, Trees(n).Azim, Trees(n).InOut, Trees(n).Cplot, Trees(n).Strip

 n = n + 1
Loop
MsgBox (n & " trees / fixed points read")
Close (1)

ReDim Preserve Trees(1 To n) As PhotoTree

Exit Sub

Virhetilanne:
MsgBox ("Virhe luettaessa rivi " & n)
Close (1)

End Sub

Private Sub Simulate_Click()



Dim StopBit As Long, NumOfLSAITe As Long, k As Long
Dim Plotpoints As Boolean
Dim StdevX As Double, StdevY As Double
Dim Xerr As Double, Yerr As Double
Dim XerrSum As Double, YerrSum As Double
Dim SigmaNUllSum As Double, SigmaYsum As Double, sigmaXsum As Double
Dim XerrSum2 As Double, YerrSum2 As Double
Dim Nvalid As Long

Plotpoints = True
Call DrawLines(Plotpoints)
Call Open_Input_Parameters
Call AssignTaus
'Call CreateP0

Rem Start of simulation with given constellation
'Call PrintOutputForSimu
Open InputParam.OutputFilename For Output As 1
Close (1)

Form1.List1.Clear
Form1.List1.AddItem "C Nite Plot Tree   X-sol       Y-sol      SigmaN SigX SigY Status"
For k = 1 To nobs
 
 Rem Assign values for observations of four type
 Call AssignPointsPAandTrueObservations(k)
 Rem assign booleans for distance and azimuth
 Call DefineObservations(k)
 Call PerformPhotogrammetricObservations(k)
 Call PerformFieldObservations(k)
 
 Call InitialApproximation(k)

StartOfRecalculation:
 
 NumOfLSAITe = 0
 StopBit = CONTINUE
 Do Until (StopBit = FINISH Or NumOfLSAITe = 20)
  NumOfLSAITe = NumOfLSAITe + 1
  Call CreateMatricesAndVectorsForLSA(k)
  Call SolveLSAInMatlab(StopBit, k)
 Loop
 Rem Check if any observation has Baarda's test value in baarda() above critical in tau()
 Rem We can only use this test for redundancy of 2 and above
 Dim BaardaAffected As Boolean
 
 BaardaAffected = False
 
 GoTo OMitBaarda
 If (NumOfObservations - 2) > 1 Then
  For i = 1 To InputParam.NPA
  
   If obs(i).ISdist = True And obs(i).idDist = MaxBaardaIndex Then
    If Abs(Baarda(MaxBaardaIndex)) > tau(NumOfObservations - 2) Then
     obs(i).ISdist = False
     BaardaAffected = True
     fff = obs(i).EpsilonDist
    End If
   End If
   If obs(i).ISazim = True And obs(i).idAzim = MaxBaardaIndex Then
    If Abs(Baarda(MaxBaardaIndex)) > tau(NumOfObservations - 2) Then
     obs(i).ISazim = False
     BaardaAffected = True
     fff = obs(i).EpsilonAzim
    End If
   End If
  Next i
 End If
 
If BaardaAffected = True Then
   StopBit = RECALCULATE
   GoTo StartOfRecalculation
End If


OMitBaarda:

Call DrawObs(Plotpoints)
Call PrintOutputPerIte(k, NumOfLSAITe)
 
Rem Here we compute mean and standard deviation variables
Xerr = P0.TruePos.X - P0.InitialPos.X
Yerr = P0.TruePos.Y - P0.InitialPos.Y
If Abs(Xerr) < 3 And Abs(Yerr < 3) Then
 Nvalid = Nvalid + 1
 XerrSum = XerrSum + Xerr
 XerrSum2 = XerrSum2 + Xerr ^ 2
 YerrSum = YerrSum + Yerr
 YerrSum2 = YerrSum2 + Yerr ^ 2
 SigmaNUllSum = SigmaNUllSum + sigmaNull
 sigmaXsum = sigmaXsum + sigmaX
 SigmaYsum = SigmaYsum + sigmaY
End If


Next k
MsgBox ("Ready! Results are in file " & InputParam.OutputFilename)
Exit Sub

Form1.Picture1.CurrentX = 10
Form1.Picture1.CurrentY = 300
Form1.Picture1.Print "Mean(dX): " & Format$(XerrSum / Nvalid, "0.00")
Form1.Picture1.CurrentX = 10
Form1.Picture1.CurrentY = 320
Form1.Picture1.Print "Mean(dY): " & Format$(YerrSum / Nvalid, "0.00")
Form1.Picture1.CurrentX = 10
Form1.Picture1.CurrentY = 340
Form1.Picture1.Print "SD(dX): " & Format$(Sqr(XerrSum2 / (Nvalid - 1)), "0.000")
Form1.Picture1.CurrentX = 10
Form1.Picture1.CurrentY = 360
Form1.Picture1.Print "SD(dY): " & Format$(Sqr(YerrSum2 / (Nvalid - 1)), "0.000")
Form1.Picture1.CurrentX = 10
Form1.Picture1.CurrentY = 380
Form1.Picture1.Print "Valid(%): " & Format$(100 * (Nvalid / InputParam.NumberOfSimulations), "0.0")
Form1.Picture1.CurrentX = 10
Form1.Picture1.CurrentY = 400
Form1.Picture1.Print "mean(sigmaNull): " & Format$((SigmaNUllSum / Nvalid), "0.00")
Form1.Picture1.CurrentX = 10
Form1.Picture1.CurrentY = 420
Form1.Picture1.Print "mean(sigmaX): " & Format$((sigmaXsum / Nvalid), "0.000")
Form1.Picture1.CurrentX = 10
Form1.Picture1.CurrentY = 440
Form1.Picture1.Print "mean(sigmaY): " & Format$((SigmaYsum / Nvalid), "0.000")







MsgBox ("Done!")

End Sub

